diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetConfigEntries.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetConfigEntries.java
index 1ff06416e183f1d5ff060eee00bcc80588ab0796..c9a900a0bedb0099c4715b19713b4e6f2acd0fec 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetConfigEntries.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetConfigEntries.java
@@ -141,7 +141,7 @@ public class GetConfigEntries extends CMSServlet {
             while (t.hasMoreTokens()) {
                 String name1 = t.nextToken();
                 IConfigStore cs = config.getSubStore(name1);
-                Enumeration enum1 = cs.getPropertyNames();
+                Enumeration<String> enum1 = cs.getPropertyNames();
 
                 while (enum1.hasMoreElements()) {
                     String name = name1 + "." + enum1.nextElement();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetDomainXML.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetDomainXML.java
index 04d88dba747b315f1de0efa98e6ed4c4ca2b3723..45c5192aa5571626b8653b9d720d35174151e7b1 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetDomainXML.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/GetDomainXML.java
@@ -144,9 +144,10 @@ public class GetDomainXML extends CMSServlet {
                             Node node = xmlObj.createContainer(listNode, subType);
                             LDAPEntry entry = res2.next();
                             LDAPAttributeSet entryAttrs = entry.getAttributeSet();
-                            Enumeration attrsInSet = entryAttrs.getAttributes();
+                            @SuppressWarnings("unchecked")
+                            Enumeration<LDAPAttribute> attrsInSet = entryAttrs.getAttributes();
                             while (attrsInSet.hasMoreElements()) {
-                                LDAPAttribute nextAttr = (LDAPAttribute) attrsInSet.nextElement();
+                                LDAPAttribute nextAttr = attrsInSet.nextElement();
                                 String attrName = nextAttr.getName();
                                 if ((!attrName.equals("cn")) && (!attrName.equals("objectClass"))) {
                                     String attrValue = (String) nextAttr.getStringValues().nextElement();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ModulePanel.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ModulePanel.java
index f33b10230494401774f7cafa6eb9ed8f28554a33..00474615f4106ec21d262fe4a709086c5448a11e 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/ModulePanel.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/ModulePanel.java
@@ -45,9 +45,9 @@ import com.netscape.cmsutil.crypto.Module;
 
 public class ModulePanel extends WizardPanelBase {
     private CryptoManager mCryptoManager = null;
-    private Vector mSupportedModules = null;
-    private Vector mOtherModules = null;
-    private Hashtable mCurrModTable = new Hashtable();
+    private Vector<Module> mSupportedModules = null;
+    private Vector<Module> mOtherModules = null;
+    private Hashtable<String, PK11Module> mCurrModTable = new Hashtable<String, PK11Module>();
     private WizardServlet mServlet = null;
 
     public ModulePanel() {
@@ -79,10 +79,11 @@ public class ModulePanel extends WizardPanelBase {
         try {
             // getting existing modules
             mCryptoManager = CryptoManager.getInstance();
-            Enumeration modules = mCryptoManager.getModules();
+            @SuppressWarnings("unchecked")
+            Enumeration<PK11Module> modules = mCryptoManager.getModules();
 
             while (modules.hasMoreElements()) {
-                PK11Module mod = (PK11Module) modules.nextElement();
+                PK11Module mod = modules.nextElement();
 
                 CMS.debug("ModulePanel: got module " + mod.getName());
                 mCurrModTable.put(mod.getName(), mod);
@@ -99,16 +100,16 @@ public class ModulePanel extends WizardPanelBase {
      * Modules not listed as supported modules
      */
     public void loadOtherModules() {
-        Enumeration m = mCurrModTable.elements();
+        Enumeration<PK11Module> m = mCurrModTable.elements();
 
-        mOtherModules = new Vector();
+        mOtherModules = new Vector<Module>();
         while (m.hasMoreElements()) {
-            PK11Module mod = (PK11Module) m.nextElement();
-            Enumeration s = mSupportedModules.elements();
+            PK11Module mod = m.nextElement();
+            Enumeration<Module> s = mSupportedModules.elements();
             boolean found = false;
 
             while (s.hasMoreElements()) {
-                Module sm = (Module) s.nextElement();
+                Module sm = s.nextElement();
 
                 if (mod.getName().equals(sm.getCommonName())) {
                     found = true;
@@ -123,7 +124,7 @@ public class ModulePanel extends WizardPanelBase {
 
                 loadModTokens(module, mod);
                 module.setFound(true);
-                mOtherModules.addElement((Object) module);
+                mOtherModules.addElement(module);
                 break;
             }
         }// while
@@ -133,11 +134,12 @@ public class ModulePanel extends WizardPanelBase {
      * find all tokens belonging to a module and load the Module
      */
     public void loadModTokens(Module module, PK11Module mod) {
-        Enumeration tokens = mod.getTokens();
+        @SuppressWarnings("unchecked")
+        Enumeration<CryptoToken> tokens = mod.getTokens();
 
         while (tokens.hasMoreElements()) {
             try {
-                CryptoToken token = (CryptoToken) tokens.nextElement();
+                CryptoToken token = tokens.nextElement();
 
                 CMS.debug("ModulePanel: token nick name=" + token.getName());
                 CMS.debug("ModulePanel: token logged in?" + token.isLoggedIn());
@@ -164,7 +166,7 @@ public class ModulePanel extends WizardPanelBase {
 
         // getting supported security modules
         // a Vectgor of Modules
-        mSupportedModules = new Vector();
+        mSupportedModules = new Vector<Module>();
         // read from conf store all supported modules
         try {
             int count = CMS.getConfigStore().getInteger(
@@ -191,7 +193,7 @@ public class ModulePanel extends WizardPanelBase {
                     CMS.debug("ModulePanel: module found: " + cn);
                     module.setFound(true);
                     // add token info to module vector
-                    PK11Module m = (PK11Module) mCurrModTable.get(cn);
+                    PK11Module m = mCurrModTable.get(cn);
 
                     loadModTokens(module, m);
                 }
@@ -199,7 +201,7 @@ public class ModulePanel extends WizardPanelBase {
                 CMS.debug("ModulePanel: adding module " + cn);
                 // add module to set
                 if (!mSupportedModules.contains(module)) {
-                    mSupportedModules.addElement((Object) module);
+                    mSupportedModules.addElement(module);
                 }
             }// for
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java
index 9e0ca6f381d47efa33d72a066d60f490707964d4..da721b29cc944a753146989104be49696c6b3a64 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java
@@ -50,7 +50,7 @@ import com.netscape.cms.servlet.wizard.WizardServlet;
 import com.netscape.cmsutil.crypto.CryptoUtil;
 
 public class NamePanel extends WizardPanelBase {
-    private Vector mCerts = null;
+    private Vector<Cert> mCerts = null;
     private WizardServlet mServlet = null;
 
     public NamePanel() {
@@ -172,7 +172,7 @@ public class NamePanel extends WizardPanelBase {
             CMS.setConfigSDSessionId(session_id);
         }
 
-        mCerts = new Vector();
+        mCerts = new Vector<Cert>();
 
         String domainname = "";
         IConfigStore config = CMS.getConfigStore();
@@ -320,10 +320,10 @@ public class NamePanel extends WizardPanelBase {
     public void validate(HttpServletRequest request,
             HttpServletResponse response,
             Context context) throws IOException {
-        Enumeration c = mCerts.elements();
+        Enumeration<Cert> c = mCerts.elements();
 
         while (c.hasMoreElements()) {
-            Cert cert = (Cert) c.nextElement();
+            Cert cert = c.nextElement();
             // get the dn's and put in config
             if (cert.isEnable()) {
                 String dn = HttpInput.getDN(request, cert.getCertTag());
@@ -632,11 +632,11 @@ public class NamePanel extends WizardPanelBase {
             HttpServletResponse response,
             Context context, String tag) throws IOException {
         CMS.debug("NamePanel: configCertWithTag start");
-        Enumeration c = mCerts.elements();
+        Enumeration<Cert> c = mCerts.elements();
         IConfigStore config = CMS.getConfigStore();
 
         while (c.hasMoreElements()) {
-            Cert cert = (Cert) c.nextElement();
+            Cert cert = c.nextElement();
             String ct = cert.getCertTag();
             CMS.debug("NamePanel: configCertWithTag ct=" + ct +
                         " tag=" + tag);
@@ -673,10 +673,10 @@ public class NamePanel extends WizardPanelBase {
 
         boolean hasChanged = false;
         try {
-            Enumeration c = mCerts.elements();
+            Enumeration<Cert> c = mCerts.elements();
 
             while (c.hasMoreElements()) {
-                Cert cert = (Cert) c.nextElement();
+                Cert cert = c.nextElement();
                 String ct = cert.getCertTag();
                 boolean enable = config.getBoolean(PCERT_PREFIX + ct + ".enable", true);
                 if (!enable)
@@ -828,10 +828,10 @@ public class NamePanel extends WizardPanelBase {
 
         try {
 
-            Enumeration c = mCerts.elements();
+            Enumeration<Cert> c = mCerts.elements();
 
             while (c.hasMoreElements()) {
-                Cert cert = (Cert) c.nextElement();
+                Cert cert = c.nextElement();
                 String ct = cert.getCertTag();
                 String tokenname = cert.getTokenname();
                 boolean enable = config.getBoolean(PCERT_PREFIX + ct + ".enable", true);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/csadmin/WizardPanelBase.java b/pki/base/common/src/com/netscape/cms/servlet/csadmin/WizardPanelBase.java
index 93893bff115f177344d01b40d9e732625fae9110..a56230c2ff0c254dda9e8823edafa826da011b69 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/csadmin/WizardPanelBase.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/csadmin/WizardPanelBase.java
@@ -1077,10 +1077,10 @@ public class WizardPanelBase implements IWizardPanel {
         return v;
     }
 
-    public Vector getUrlListFromSecurityDomain(IConfigStore config,
+    public Vector<String> getUrlListFromSecurityDomain(IConfigStore config,
                                                 String type,
                                                 String portType) {
-        Vector v = new Vector();
+        Vector<String> v = new Vector<String>();
 
         try {
             String hostname = config.getString("securitydomain.host");
@@ -1124,13 +1124,13 @@ public class WizardPanelBase implements IWizardPanel {
 
             CMS.debug("Len " + len);
             for (int i = 0; i < len; i++) {
-                Vector v_name = parser.getValuesFromContainer(nodeList.item(i),
+                Vector<String> v_name = parser.getValuesFromContainer(nodeList.item(i),
                         "SubsystemName");
-                Vector v_host = parser.getValuesFromContainer(nodeList.item(i),
+                Vector<String> v_host = parser.getValuesFromContainer(nodeList.item(i),
                         "Host");
-                Vector v_port = parser.getValuesFromContainer(nodeList.item(i),
+                Vector<String> v_port = parser.getValuesFromContainer(nodeList.item(i),
                         portType);
-                Vector v_admin_port = parser.getValuesFromContainer(nodeList.item(i),
+                Vector<String> v_admin_port = parser.getValuesFromContainer(nodeList.item(i),
                         "SecureAdminPort");
 
                 if (v_host.elementAt(0).equals(hostname)
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/GetApprovalStatus.java b/pki/base/common/src/com/netscape/cms/servlet/key/GetApprovalStatus.java
index 79bb937eddc47c2927d0c207904fbf10767b8845..0019c95084ec421dc27e79f22339f52b971a09bc 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/GetApprovalStatus.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/GetApprovalStatus.java
@@ -142,7 +142,7 @@ public class GetApprovalStatus extends CMSServlet {
 
             header.addStringValue("recoveryID", recoveryID);
 
-            Hashtable params = mService.getRecoveryParams(recoveryID);
+            Hashtable<String, Object> params = mService.getRecoveryParams(recoveryID);
 
             if (params == null) {
                 log(ILogger.LL_FAILURE,
@@ -157,13 +157,13 @@ public class GetApprovalStatus extends CMSServlet {
 
             header.addIntegerValue("noOfRequiredAgents", requiredNumber);
 
-            Vector dc = ((IKeyRecoveryAuthority) mService).getAppAgents(recoveryID);
-            Enumeration agents = dc.elements();
+            Vector<Credential> dc = ((IKeyRecoveryAuthority) mService).getAppAgents(recoveryID);
+            Enumeration<Credential> agents = dc.elements();
 
             while (agents.hasMoreElements()) {
                 IArgBlock rarg = CMS.createArgBlock();
 
-                rarg.addStringValue("agentName", ((Credential) agents.nextElement()).getIdentifier());
+                rarg.addStringValue("agentName", agents.nextElement().getIdentifier());
                 argSet.addRepeatRecord(rarg);
             }
             if (dc.size() >= requiredNumber) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileApproveServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileApproveServlet.java
index ebd0b6c0c62f8c7220a75cb5c49c02f6aa18c27a..48848695f4b89cb7e94b3b446b98b6cb2f473603 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileApproveServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileApproveServlet.java
@@ -371,20 +371,19 @@ public class ProfileApproveServlet extends ProfileServlet {
             return;
         }
 
-        Enumeration policySetIds = profile.getProfilePolicySetIds();
+        Enumeration<String> policySetIds = profile.getProfilePolicySetIds();
 
         ArgList setlist = new ArgList();
 
         while (policySetIds.hasMoreElements()) {
-            String setId = (String) policySetIds.nextElement();
+            String setId = policySetIds.nextElement();
 
-            Enumeration policyIds = profile.getProfilePolicyIds(setId);
+            Enumeration<String> policyIds = profile.getProfilePolicyIds(setId);
             ArgList list = new ArgList();
 
             while (policyIds.hasMoreElements()) {
-                String id = (String) policyIds.nextElement();
-                IProfilePolicy policy = (IProfilePolicy)
-                        profile.getProfilePolicy(setId, id);
+                String id = policyIds.nextElement();
+                IProfilePolicy policy = profile.getProfilePolicy(setId, id);
 
                 // (3) query all the profile policies
                 // (4) default plugins convert request parameters
@@ -424,12 +423,12 @@ public class ProfileApproveServlet extends ProfileServlet {
         set.set(ARG_DEF_DESC, dDesc);
 
         ArgList deflist = new ArgList();
-        Enumeration defNames = def.getValueNames();
+        Enumeration<String> defNames = def.getValueNames();
 
         if (defNames != null) {
             while (defNames.hasMoreElements()) {
                 ArgSet defset = new ArgSet();
-                String defName = (String) defNames.nextElement();
+                String defName = defNames.nextElement();
                 IDescriptor defDesc = def.getValueDescriptor(locale, defName);
                 if (defDesc == null) {
                     CMS.debug("defName=" + defName);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileListServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileListServlet.java
index 8581b3caa957dc407530b5ec4177195c0a5f37d4..2ca5f0a5cc3d90c577cbfd9174249cd6ccb7a79c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileListServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileListServlet.java
@@ -126,7 +126,7 @@ public class ProfileListServlet extends ProfileServlet {
         }
 
         ArgList list = new ArgList();
-        Enumeration e = ps.getProfileIds();
+        Enumeration<String> e = ps.getProfileIds();
 
         if (e != null) {
             while (e.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
index 8a8d65d90ac72c95746c5173766a26c67de91afd..3c75be021637b66a589bd582ed5b06f1d5859ca8 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
@@ -60,6 +60,7 @@ import com.netscape.certsrv.request.RequestStatus;
 import com.netscape.certsrv.template.ArgList;
 import com.netscape.certsrv.template.ArgSet;
 import com.netscape.certsrv.util.IStatsSubsystem;
+import com.netscape.cms.profile.common.ProfilePolicy;
 import com.netscape.cms.servlet.common.CMSRequest;
 
 /**
@@ -691,11 +692,11 @@ public class ProfileProcessServlet extends ProfileServlet {
             req.setRequestStatus(RequestStatus.COMPLETE);
 
             ArgList outputlist = new ArgList();
-            Enumeration outputIds = profile.getProfileOutputIds();
+            Enumeration<String> outputIds = profile.getProfileOutputIds();
 
             if (outputIds != null) {
                 while (outputIds.hasMoreElements()) {
-                    String outputId = (String) outputIds.nextElement();
+                    String outputId = outputIds.nextElement();
                     IProfileOutput profileOutput = profile.getProfileOutput(
                             outputId);
 
@@ -779,11 +780,11 @@ public class ProfileProcessServlet extends ProfileServlet {
             throws ERejectException, EDeferException, EPropertyException {
         String profileSetId = req.getExtDataInString("profileSetId");
 
-        Enumeration policies = profile.getProfilePolicies(profileSetId);
+        Enumeration<ProfilePolicy> policies = profile.getProfilePolicies(profileSetId);
         int count = 0;
 
         while (policies.hasMoreElements()) {
-            IProfilePolicy policy = (IProfilePolicy) policies.nextElement();
+            ProfilePolicy policy = policies.nextElement();
 
             setValue(locale, count, policy, req, request);
             count++;
@@ -792,7 +793,7 @@ public class ProfileProcessServlet extends ProfileServlet {
         policies = profile.getProfilePolicies(profileSetId);
         count = 0;
         while (policies.hasMoreElements()) {
-            IProfilePolicy policy = (IProfilePolicy) policies.nextElement();
+            ProfilePolicy policy = policies.nextElement();
 
             validate(locale, count, policy, req, request);
             count++;
@@ -821,10 +822,10 @@ public class ProfileProcessServlet extends ProfileServlet {
             throws EPropertyException {
         // handle default policy
         IPolicyDefault def = policy.getDefault();
-        Enumeration defNames = def.getValueNames();
+        Enumeration<String> defNames = def.getValueNames();
 
         while (defNames.hasMoreElements()) {
-            String defName = (String) defNames.nextElement();
+            String defName = defNames.nextElement();
             String defValue = request.getParameter(defName);
 
             def.setValue(defName, locale, req, defValue);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileReviewServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileReviewServlet.java
index 11aaa74997489b3a0af8a8fa33ac0e0de25cca67..6c273311571907df795416f7a6bf266431204fdc 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileReviewServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileReviewServlet.java
@@ -234,15 +234,15 @@ public class ProfileReviewServlet extends ProfileServlet {
         String profileSetId = req.getExtDataInString("profileSetId");
 
         CMS.debug("ProfileReviewServlet: profileSetId=" + profileSetId);
-        Enumeration policyIds = (profileSetId != null && profileSetId.length() > 0) ?
+        Enumeration<String> policyIds = (profileSetId != null && profileSetId.length() > 0) ?
                                  profile.getProfilePolicyIds(profileSetId) : null;
         int count = 0;
         ArgList list = new ArgList();
 
         if (policyIds != null) {
             while (policyIds.hasMoreElements()) {
-                String id = (String) policyIds.nextElement();
-                IProfilePolicy policy = (IProfilePolicy)
+                String id = policyIds.nextElement();
+                IProfilePolicy policy =
                         profile.getProfilePolicy(req.getExtDataInString("profileSetId"),
                                 id);
 
@@ -306,19 +306,19 @@ public class ProfileReviewServlet extends ProfileServlet {
         // populate authentication parameters
 
         // populate input parameters
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
-                String inputId = (String) inputIds.nextElement();
+                String inputId = inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
 
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 if (inputNames != null) {
                     while (inputNames.hasMoreElements()) {
                         ArgSet inputset = new ArgSet();
-                        String inputName = (String) inputNames.nextElement();
+                        String inputName = inputNames.nextElement();
 
                         IDescriptor inputDesc = profileInput.getValueDescriptor(locale, inputName);
 
@@ -350,20 +350,20 @@ public class ProfileReviewServlet extends ProfileServlet {
         // if request in complete state
 
         ArgList outputlist = new ArgList();
-        Enumeration outputIds = profile.getProfileOutputIds();
+        Enumeration<String> outputIds = profile.getProfileOutputIds();
 
         if (outputIds != null) {
             while (outputIds.hasMoreElements()) {
-                String outputId = (String) outputIds.nextElement();
+                String outputId = outputIds.nextElement();
                 IProfileOutput profileOutput = profile.getProfileOutput(outputId
                         );
 
-                Enumeration outputNames = profileOutput.getValueNames();
+                Enumeration<String> outputNames = profileOutput.getValueNames();
 
                 if (outputNames != null) {
                     while (outputNames.hasMoreElements()) {
                         ArgSet outputset = new ArgSet();
-                        String outputName = (String) outputNames.nextElement
+                        String outputName = outputNames.nextElement
                                 ();
                         IDescriptor outputDesc =
                                 profileOutput.getValueDescriptor(locale, outputName);
@@ -412,12 +412,12 @@ public class ProfileReviewServlet extends ProfileServlet {
 
         set.set(ARG_DEF_DESC, dDesc);
         ArgList deflist = new ArgList();
-        Enumeration defNames = def.getValueNames();
+        Enumeration<String> defNames = def.getValueNames();
 
         if (defNames != null) {
             while (defNames.hasMoreElements()) {
                 ArgSet defset = new ArgSet();
-                String defName = (String) defNames.nextElement();
+                String defName = defNames.nextElement();
                 IDescriptor defDesc = def.getValueDescriptor(locale, defName);
 
                 if (defDesc == null)
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSelectServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSelectServlet.java
index 462c628b2fa2c0e146fdf79d38229fb9b018d859..5b07951f8f176f8fc5552cda90044943eb022cd3 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSelectServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSelectServlet.java
@@ -189,18 +189,18 @@ public class ProfileSelectServlet extends ProfileServlet {
         }
 
         ArgList setlist = new ArgList();
-        Enumeration policySetIds = profile.getProfilePolicySetIds();
+        Enumeration<String> policySetIds = profile.getProfilePolicySetIds();
 
         if (policySetIds != null) {
             while (policySetIds.hasMoreElements()) {
-                String setId = (String) policySetIds.nextElement();
+                String setId = policySetIds.nextElement();
 
                 ArgList list = new ArgList();
-                Enumeration policyIds = profile.getProfilePolicyIds(setId);
+                Enumeration<String> policyIds = profile.getProfilePolicyIds(setId);
 
                 if (policyIds != null) {
                     while (policyIds.hasMoreElements()) {
-                        String id = (String) policyIds.nextElement();
+                        String id = policyIds.nextElement();
                         IProfilePolicy policy = (IProfilePolicy)
                                 profile.getProfilePolicy(setId, id);
 
@@ -264,12 +264,12 @@ public class ProfileSelectServlet extends ProfileServlet {
         }
 
         if (authenticator != null) {
-            Enumeration authNames = authenticator.getValueNames();
+            Enumeration<String> authNames = authenticator.getValueNames();
 
             if (authNames != null) {
                 while (authNames.hasMoreElements()) {
                     ArgSet authset = new ArgSet();
-                    String authName = (String) authNames.nextElement();
+                    String authName = authNames.nextElement();
                     IDescriptor authDesc =
                             authenticator.getValueDescriptor(locale, authName);
 
@@ -296,11 +296,11 @@ public class ProfileSelectServlet extends ProfileServlet {
         // build input list
         ArgList inputlist = new ArgList();
         ArgList inputPluginlist = new ArgList();
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
-                String inputId = (String) inputIds.nextElement();
+                String inputId = inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
 
                 if (profileInput != null) {
@@ -313,12 +313,12 @@ public class ProfileSelectServlet extends ProfileServlet {
                             profileInput.getText(locale));
                     inputPluginlist.add(inputpluginset);
 
-                    Enumeration inputNames = profileInput.getValueNames();
+                    Enumeration<String> inputNames = profileInput.getValueNames();
 
                     if (inputNames != null) {
                         while (inputNames.hasMoreElements()) {
                             ArgSet inputset = new ArgSet();
-                            String inputName = (String) inputNames.nextElement();
+                            String inputName = inputNames.nextElement();
                             IDescriptor inputDesc = profileInput.getValueDescriptor(
                                     locale, inputName);
 
@@ -362,12 +362,12 @@ public class ProfileSelectServlet extends ProfileServlet {
 
         set.set(ARG_DEF_DESC, dDesc);
         ArgList deflist = new ArgList();
-        Enumeration defNames = def.getValueNames();
+        Enumeration<String> defNames = def.getValueNames();
 
         if (defNames != null) {
             while (defNames.hasMoreElements()) {
                 ArgSet defset = new ArgSet();
-                String defName = (String) defNames.nextElement();
+                String defName = defNames.nextElement();
                 IDescriptor defDesc = def.getValueDescriptor(locale, defName);
 
                 if (defDesc == null)
@@ -393,11 +393,11 @@ public class ProfileSelectServlet extends ProfileServlet {
 
         set.set(ARG_CON_DESC, conDesc);
         ArgList conlist = new ArgList();
-        Enumeration conNames = con.getConfigNames();
+        Enumeration<String> conNames = con.getConfigNames();
         if (conNames != null) {
             while (conNames.hasMoreElements()) {
                 ArgSet conset = new ArgSet();
-                String conName = (String) conNames.nextElement();
+                String conName = conNames.nextElement();
                 conset.set(ARG_CON_NAME, conName);
                 conset.set(ARG_CON_VALUE, con.getConfig(conName));
                 conlist.add(conset);
